package net.minecraft.server;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Tool extends Item
{

    public Tool(boolean usingSAPI, ToolBase toolBase, int itemID, int uses, float baseDamage, float basePower, float toolSpeed) {
        this(usingSAPI, toolBase, itemID, uses, baseDamage, basePower, toolSpeed, 1.0F);
    }

    public Tool(boolean usingSAPI, ToolBase toolBase, int itemID, int uses, float baseDamage, float basePower, float toolSpeed, 
            float defaultSpeed) {
        super(itemID);
        mineBlocks = new ArrayList<BlockHarvestPower>();
        mineMaterials = new ArrayList<Material>();
        d(uses);
        maxStackSize = 1;
        this.usingSAPI = usingSAPI;
        this.toolBase = toolBase;
        this.baseDamage = baseDamage;
        this.basePower = basePower;
        this.toolSpeed = toolSpeed;
        this.defaultSpeed = defaultSpeed;
    }
    
    @Override
    public boolean a(ItemStack stack, EntityLiving living, EntityLiving living2) {
        stack.damage(2, living2);
        return true;
    }
    
    @Override
    public boolean a(ItemStack stack, int blockID, int x, int y, int z, EntityLiving living) {
        stack.damage(1, living);
        return true;
    }
    
    @Override
    public int a(Entity entity) {
        return (int)Math.floor(baseDamage);
    }
    
    public float getPower() {
        return basePower;
    }
    
    @Override
    public float a(ItemStack stack, Block block) {
        return canHarvest(block) ? toolSpeed : defaultSpeed;
    }
    
    public boolean canHarvest(Block block) {
        if(toolBase != null && toolBase.canHarvest(block, getPower()))
            return true;
        for(Iterator<Material> iterator = mineMaterials.iterator(); iterator.hasNext();) {
            Material material = (Material)iterator.next();
            if(material == block.material)
                return true;
        }

        for(Iterator<BlockHarvestPower> iterator1 = mineBlocks.iterator(); iterator1.hasNext();) {
            BlockHarvestPower power = (BlockHarvestPower)iterator1.next();
            if(block.id == power.blockID || getPower() >= power.percentage)
                return true;
        }

        return false;
    }

    public final boolean usingSAPI;
    public ToolBase toolBase;
    public final float baseDamage;
    public final float basePower;
    public final float defaultSpeed;
    public final float toolSpeed;
    public List<BlockHarvestPower> mineBlocks;
    public List<Material> mineMaterials;

    static {
        SAPI.showText();
    }
}
